/* *********************************************************************** */ 
/*                          Smus2Sco v2.0                                  */
/*                       1990 Jean-Francois Giorgi                         */
/* *********************************************************************** */ 

#include "smus2sco.h"

/* *********************** */
/* smus2sco.c : main module */
/* *********************** */

/* *********************************************************************** */
/* some globals */
char *ProgName;
char Usage_Help[100] = " [-a] [-d] [-so] [-/+1/2] smus-file [csound-sco-file] [instruments-path]";
char *IPath; /* instruments directory for GenSound */

BOOL DefTI;
BOOL ScoreOnly;
BOOL AnalOnly;
WORD GTranspose;

struct Score *The_Score;
struct Instruments *InstrList;

char namebuff[500];

/* *********************************************************************** */       
/* exit with a message */
VOID pexit(s)
char *s;
{

  fprintf(stderr,s);
  fprintf(stderr,"\n");
  exit(0);
}
/* *********************************************************************** */       
/* query for yes */

BOOL GetRep()
{
  char c;

  c=getchar();
  while(getchar() != '\n');
  if (c=='y') return(TRUE);
  return(FALSE);
}

/* *********************************************************************** */       
/* fill a string with zeros */
VOID FillZero(s,l)
char *s;
WORD l;
{
  register WORD i;
  register char *ss;

  for (i=0,ss=s;i<l;i++) *ss++ = (char)0;

}
/* *********************************************************************** */       
/* Initialize instruments */
VOID InitLI()
{
  WORD ic;

  InstrList->its_num  = 0;
  InstrList->its_cour = NO_INSTR;

  for (ic=0;ic<MAX_INST;ic++) {
    InstrList->its_NumPN[ic]        = 0L;       /* played note                        */
    InstrList->its_Used[ic]         = FALSE;    /* if used                            */
    InstrList->its_MinTone[ic]      = 0xff;     /* minimal note                       */
    InstrList->its_MaxTone[ic]      = 0;        /* maximal note                       */
    IRegs[ic]                       = NO_INSTR; /* all registers are unallocated      */
  }
}
/* *********************************************************************** */       
/* remove from InstrList unused instruments */
VOID CleanInstrList() 
{
  register WORD i; 
  register WORD iu,id; 
  BOOL un,dn;

  char *s;

  for (i=0;i<MAX_INST;i++) { 
    if((InstrList->its_Used[i]==TRUE)) {
      s = InstrList->its_instrs[i]->name;
      if (InstrList->its_NumPN[i] == 0) {
        InstrList->its_Used[i] = FALSE;
        printf("%s totally blanked\n",s);
      }
    }
  }

}
/* *********************************************************************** */       
VOID usage()
{
  printf("Usage: %s %s\n",ProgName,Usage_Help);
  exit();
}
/* *********************************************************************** */       
/* The Main One */
main(argc,argv)
int argc;
char **argv;
{
  int i;
  char *infile,*outfile; /* input,output file names */

  printf("SMUS to CSound Converter (c) 1990 by JFG\n\n");
  ProgName = argv[0];

  DefTI = FALSE;
  ScoreOnly = FALSE;
  AnalOnly = FALSE;
  GTranspose = 0;

  if (argc <2) usage();
  for (i=1;i<argc-1;i++) {
    if (strcmp(argv[i],"-d")==0)
      if (DefTI==FALSE) DefTI = TRUE; 
      else usage();
    else if (strcmp(argv[i],"-a")==0)
      if (AnalOnly==FALSE) AnalOnly = TRUE;
      else usage();
    else if (strcmp(argv[i],"-so")==0)
      if (ScoreOnly==FALSE) ScoreOnly = TRUE;
      else usage();
    else if (strcmp(argv[i],"+1")==0)
           if (GTranspose == 0) GTranspose = 1;
           else usage();
    else if (strcmp(argv[i],"-1")==0)
           if (GTranspose == 0) GTranspose = -1;
           else usage();
    else if (strcmp(argv[i],"+2")==0)
           if (GTranspose == 0) GTranspose = 2; 
           else usage();
    else if (strcmp(argv[i],"-2")==0)
           if (GTranspose == 0) GTranspose = -2; 
           else usage();
    else break;
  }

  infile   = argv[i];    /* for clarity */
  if ((AnalOnly == FALSE) && (argc<i+2)) usage();
  outfile  = argv[1+i];  /* idem        */
  IPath = NULL;
  if (argc >i+2) IPath  = argv[2+i];  /* instrument path */

  if (getSMUS(infile)==FALSE) exit(); /* read in SMUS file */

  Anal_Score(AnalOnly); 

  if (AnalOnly == FALSE) SMUS_To_CSOUND(outfile);
 
  pexit("\n--- DONE ---\n");

}
/* ************************************************************************ */  
